#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_notify.interfaces import INotificationHandler

# import packages
from pyams_notify.event import Notification
from pyramid.view import view_config


@view_config(name='get-notifications-context.json', renderer='json', xhr=True)
def NotificationsContextView(request):
    """Get context for notifications"""
    principal = request.principal
    notification = Notification(request,
                                action='none',
                                category='notifications.query',
                                message='')
    adapters = [name for name, adapter in request.registry.getAdapters((notification, ), INotificationHandler)]
    return {'principal': {'id': principal.id,
                          'title': principal.title,
                          'principals': tuple(request.effective_principals)},
            'context': {'*': adapters}}
